import React, { useState, useRef, useEffect, useCallback, Fragment } from 'react';
import Select from 'react-select';
import makeAnimated from 'react-select/animated';
import 'react-icons/ri';
import Cropper from 'react-easy-crop';
import axios from 'axios';
import { Modal as Modal$1, Button } from 'antd';
import 'antd/dist/antd.css';

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var styles = {"darkBG":"_DEn-v","centered":"_-zPaT","modal":"_1pyOm","modalHeader":"_H7T8l","heading":"_UOLVJ","modalContent":"_1vovQ","leftInput":"_PPOh9","centerInput":"_11hht","bigCenterInput":"_HXBVd","radioButtonContainer":"_3pLsX","multiSelect":"_1mrnC","singleSelect":"_1RE6G","modalActions":"_1U-b5","actionsContainer":"_1lU9c","closeBtn":"_lHXPM","saveBtn":"_hvNpS","cancelBtn":"_HpINt","element":"_2tXlH","row":"_FVLTW","rowChild":"_7xZ07","avatar":"_2kWLb","cover":"_11OKN","imageSelectorContainer":"_eCDbB","imageCropperModalContainer":"_3Sfmh","cropButton":"_2y8E_","inputFile":"_2iRDa","fileUpload":"_NX4F3","datePickerWrapper":"_LdiEl","filePreviewLink":"_2xtxk","selectDate":"_2ieFE"};

var DatePicker = function DatePicker(_ref) {
  var ev = _ref.ev,
    queEditedValue = _ref.queEditedValue,
    setQueEditedValue = _ref.setQueEditedValue;
  var _useState = useState(""),
    day = _useState[0],
    setDay = _useState[1];
  var _useState2 = useState(""),
    month = _useState2[0],
    setMonth = _useState2[1];
  var _useState3 = useState(""),
    year = _useState3[0],
    setYear = _useState3[1];
  var date = year + "/" + month + "/" + day;
  var initialRender = useRef(true);
  var handleDatePick = function handleDatePick() {
    var qev = queEditedValue.filter(function (item) {
      return ev.id !== item.id;
    });
    qev.push({
      answer: date,
      id: ev.id
    });
    setTimeout(function () {
      setQueEditedValue(qev);
    }, 0);
  };
  useEffect(function () {
    if (!initialRender.current) {
      handleDatePick();
    } else {
      initialRender.current = false;
    }
  }, [day, month, year]);
  var days = ['روز', 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30];
  var months = ['ماه', "فروردین", "اردیبهشت", "خرداد", "تیر", "مرداد", " شهریور", "مهر", "آبان", "آذر", "دی", "بهمن", "اسفند"];
  var years = ['سال', "1380", "1382", "1383", "1384", "1385", "1386", "1387", "1388", "1389", "1390", "1391", "1392", "1393", "1394", "1395", "1396", "1397", "1398", "1399", "1400", "1401", '1402', '1403'];
  return /*#__PURE__*/React.createElement("div", {
    className: styles.datePickerWrapper
  }, /*#__PURE__*/React.createElement("select", {
    className: styles.selectDate,
    name: ev.id,
    defaultValue: ev.answer.split("/")[2],
    onChange: function onChange(e) {
      setDay(e.target.value);
    }
  }, days.map(function (day, i) {
    return /*#__PURE__*/React.createElement("option", {
      key: i
    }, day);
  })), /*#__PURE__*/React.createElement("select", {
    className: styles.selectDate,
    name: ev.id,
    defaultValue: ev.answer.split("/")[1],
    onChange: function onChange(e) {
      setMonth(e.target.value);
    }
  }, months.map(function (month, i) {
    return /*#__PURE__*/React.createElement("option", {
      key: i
    }, month);
  })), /*#__PURE__*/React.createElement("select", {
    className: styles.selectDate,
    name: ev.id,
    defaultValue: ev.answer.split("/")[0],
    onChange: function onChange(e) {
      setYear(e.target.value);
    }
  }, years.map(function (year, i) {
    return /*#__PURE__*/React.createElement("option", {
      key: i
    }, year);
  })));
};

var getCroppedImg = function getCroppedImg(imageSrc, pixelCrop, rotation, flip) {
  try {
    var _rotateSize, bBoxWidth, bBoxHeight;
    if (rotation === void 0) {
      rotation = 0;
    }
    if (flip === void 0) {
      flip = {
        horizontal: false,
        vertical: false
      };
    }
    return Promise.resolve(createImage(imageSrc)).then(function (image) {
      var canvas = document.createElement('canvas');
      var ctx = canvas.getContext('2d');
      if (!ctx) {
        return null;
      }
      var rotRad = getRadianAngle(rotation);
      _rotateSize = rotateSize(image.width, image.height, rotation);
      bBoxWidth = _rotateSize.width;
      bBoxHeight = _rotateSize.height;
      canvas.width = bBoxWidth;
      canvas.height = bBoxHeight;
      ctx.translate(bBoxWidth / 2, bBoxHeight / 2);
      ctx.rotate(rotRad);
      ctx.scale(flip.horizontal ? -1 : 1, flip.vertical ? -1 : 1);
      ctx.translate(-image.width / 2, -image.height / 2);
      ctx.drawImage(image, 0, 0);
      var croppedCanvas = document.createElement('canvas');
      var croppedCtx = croppedCanvas.getContext('2d');
      if (!croppedCtx) {
        return null;
      }
      croppedCanvas.width = pixelCrop.width;
      croppedCanvas.height = pixelCrop.height;
      croppedCtx.drawImage(canvas, pixelCrop.x, pixelCrop.y, pixelCrop.width, pixelCrop.height, 0, 0, pixelCrop.width, pixelCrop.height);
      var blob = new Promise(function (resolve, reject) {
        croppedCanvas.toBlob(function (file) {
          resolve(URL.createObjectURL(file));
        }, 'image/jpg');
      });
      return blob;
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
var createImage = function createImage(url) {
  return new Promise(function (resolve, reject) {
    var image = new Image();
    image.addEventListener('load', function () {
      return resolve(image);
    });
    image.addEventListener('error', function (error) {
      return reject(error);
    });
    image.setAttribute('crossOrigin', 'anonymous');
    image.src = url;
  });
};
function getRadianAngle(degreeValue) {
  return degreeValue * Math.PI / 180;
}
function rotateSize(width, height, rotation) {
  var rotRad = getRadianAngle(rotation);
  return {
    width: Math.abs(Math.cos(rotRad) * width) + Math.abs(Math.sin(rotRad) * height),
    height: Math.abs(Math.sin(rotRad) * width) + Math.abs(Math.cos(rotRad) * height)
  };
}

var Modal = function Modal(_ref) {
  var setModal = _ref.setModal,
    setIsOpen = _ref.setIsOpen,
    callBack = _ref.callBack,
    setEdited = _ref.setEdited,
    editableTitle = _ref.editableTitle,
    editableValue = _ref.editableValue,
    staticData = _ref.staticData,
    forWhat = _ref.forWhat;
  var animatedComponents = makeAnimated();
  var _useState = useState(editableValue),
    editedValue = _useState[0],
    setEditedValue = _useState[1];
  var _useState2 = useState([]),
    queEditedValue = _useState2[0],
    setQueEditedValue = _useState2[1];
  var _useState3 = useState(),
    selectedFile = _useState3[0],
    setSelectedFile = _useState3[1];
  var _useState4 = useState(),
    fileExtension = _useState4[0],
    setFileExtension = _useState4[1];
  var _useState5 = useState(),
    cropedFile = _useState5[0],
    setCropedFile = _useState5[1];
  var _useState6 = useState({
      x: 0,
      y: 0
    }),
    crop = _useState6[0],
    setCrop = _useState6[1];
  var _useState7 = useState(1),
    zoom = _useState7[0],
    setZoom = _useState7[1];
  var _useState8 = useState(null),
    croppedAreaPixels = _useState8[0],
    setCroppedAreaPixels = _useState8[1];
  var _useState9 = useState(0),
    rotation = _useState9[0];
  var _useState10 = useState(null),
    privateLink = _useState10[0],
    setPrivateLink = _useState10[1];
  var onCropComplete = useCallback(function (croppedArea, croppedAreaPixels) {
    setCroppedAreaPixels(croppedAreaPixels);
  }, []);
  var showCroppedImage = useCallback(function () {
    try {
      var _temp2 = _catch(function () {
        return Promise.resolve(getCroppedImg(selectedFile, croppedAreaPixels, rotation)).then(function (croppedImage) {
          setCropedFile(croppedImage);
        });
      }, function (e) {
        console.error(e);
      });
      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  }, [croppedAreaPixels, rotation]);
  var EDIT_TEXT_TEXT = 0;
  var EDIT_TEXT_NUMBER = 1;
  var DATE = 2;
  var RADIOBUTTON = 3;
  var SELECTION = 4;
  var AREA = 7;
  var WEIGHT = 8;
  var academicDegreeIdEditedValue = '';
  var _useState11 = useState(''),
    academicDegreeIdValue = _useState11[0],
    setAcademicDegreeIdValue = _useState11[1];
  var academicDegreeDefaultValue;
  if (editableTitle === 'academicDegree') {
    academicDegreeDefaultValue = {
      value: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      label: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      item: editableValue
    };
  }
  var setAcademicDegreeId = function setAcademicDegreeId(e) {
    var _e$item;
    setAcademicDegreeIdValue(e === null || e === void 0 ? void 0 : (_e$item = e.item) === null || _e$item === void 0 ? void 0 : _e$item.id);
  };
  var createAcademicDegree = function createAcademicDegree(academicDegreeId) {
    academicDegreeIdEditedValue = academicDegreeId;
  };
  var _useState12 = useState(''),
    setAcademicFieldIdValue = _useState12[1];
  var academicFieldDefaultValue;
  if (editableTitle === 'academicField') {
    academicFieldDefaultValue = {
      value: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      label: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      item: editableValue
    };
  }
  var setAcademicFieldId = function setAcademicFieldId(e) {
    var _e$item2;
    setAcademicFieldIdValue(e === null || e === void 0 ? void 0 : (_e$item2 = e.item) === null || _e$item2 === void 0 ? void 0 : _e$item2.id);
  };
  var academicRankIdEditedValue = '';
  var _useState13 = useState(''),
    academicRankIdValue = _useState13[0],
    setAcademicRankIdValue = _useState13[1];
  var academicRankDefaultValue;
  if (editableTitle === 'academicRank') {
    academicRankDefaultValue = {
      value: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      label: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      item: editableValue
    };
  }
  var setAcademicRankId = function setAcademicRankId(e) {
    var _e$item3;
    setAcademicRankIdValue(e === null || e === void 0 ? void 0 : (_e$item3 = e.item) === null || _e$item3 === void 0 ? void 0 : _e$item3.id);
  };
  var createAcademicRank = function createAcademicRank(academicRankId) {
    academicRankIdEditedValue = academicRankId;
  };
  var workplaceOrganizationPositionIdEditedValue = '';
  var _useState14 = useState(''),
    workplaceOrganizationPositionIdValue = _useState14[0],
    setWorkplaceOrganizationPositionIdValue = _useState14[1];
  var workplaceOrganizationPositionDefaultValue;
  if (editableTitle === 'workplaceOrganizationPosition') {
    workplaceOrganizationPositionDefaultValue = {
      value: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      label: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      item: editableValue
    };
  }
  var setWorkplaceOrganizationPositionId = function setWorkplaceOrganizationPositionId(e) {
    var _e$item4;
    setWorkplaceOrganizationPositionIdValue(e === null || e === void 0 ? void 0 : (_e$item4 = e.item) === null || _e$item4 === void 0 ? void 0 : _e$item4.id);
  };
  var createWorkplaceOrganizationPosition = function createWorkplaceOrganizationPosition(workplaceOrganizationPositionId) {
    workplaceOrganizationPositionIdEditedValue = workplaceOrganizationPositionId;
  };
  var workplaceOrganizationTypeIdEditedValue = '';
  var _useState15 = useState(''),
    workplaceOrganizationTypeIdValue = _useState15[0],
    setWorkplaceOrganizationTypeIdValue = _useState15[1];
  var workplaceOrganizationTypeDefaultValue;
  if (editableTitle === 'workplaceOrganizationType') {
    workplaceOrganizationTypeDefaultValue = {
      value: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      label: editableValue === null || editableValue === void 0 ? void 0 : editableValue.name,
      item: editableValue
    };
  }
  var setWorkplaceOrganizationTypeId = function setWorkplaceOrganizationTypeId(e) {
    var _e$item5;
    setWorkplaceOrganizationTypeIdValue(e === null || e === void 0 ? void 0 : (_e$item5 = e.item) === null || _e$item5 === void 0 ? void 0 : _e$item5.id);
  };
  var createWorkplaceOrganizationType = function createWorkplaceOrganizationType(workplaceOrganizationTypeId) {
    workplaceOrganizationTypeIdEditedValue = workplaceOrganizationTypeId;
  };
  var activityFieldsEditedValue = [];
  var _useState16 = useState([]),
    activityFieldsValue = _useState16[0],
    setActivityFieldsValue = _useState16[1];
  var activityFieldsDefaultValue;
  if (editableTitle === 'activityFields') {
    activityFieldsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXECUTIVE_SKILLS_ACTIVITY') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
  }
  var setActivities = function setActivities(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setActivityFieldsValue(items);
  };
  var createActivities = function createActivities(fieldName) {
    (fieldName === null || fieldName === void 0 ? void 0 : fieldName.length) > 0 && (fieldName === null || fieldName === void 0 ? void 0 : fieldName.map(function (item) {
      activityFieldsEditedValue === null || activityFieldsEditedValue === void 0 ? void 0 : activityFieldsEditedValue.push({
        categoryEN: item === null || item === void 0 ? void 0 : item.categoryEN,
        categoryFA: item === null || item === void 0 ? void 0 : item.categoryFA,
        id: item === null || item === void 0 ? void 0 : item.id,
        name: item === null || item === void 0 ? void 0 : item.name
      });
    }));
  };
  var consultingFieldsEditedValue = [];
  var _useState17 = useState([]),
    consultingFieldsValue = _useState17[0],
    setConsultingFieldsValue = _useState17[1];
  var consultingFieldsDefaultValue;
  if (editableTitle === 'consultingFields') {
    consultingFieldsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXECUTIVE_SKILLS_CONSULTING') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
  }
  var setConsultings = function setConsultings(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setConsultingFieldsValue(items);
  };
  var createConsultings = function createConsultings(fieldName) {
    (fieldName === null || fieldName === void 0 ? void 0 : fieldName.length) > 0 && (fieldName === null || fieldName === void 0 ? void 0 : fieldName.map(function (item) {
      consultingFieldsEditedValue === null || consultingFieldsEditedValue === void 0 ? void 0 : consultingFieldsEditedValue.push({
        categoryEN: item === null || item === void 0 ? void 0 : item.categoryEN,
        categoryFA: item === null || item === void 0 ? void 0 : item.categoryFA,
        id: item === null || item === void 0 ? void 0 : item.id,
        name: item === null || item === void 0 ? void 0 : item.name
      });
    }));
  };
  var expertisesEditedValue = [];
  var _useState18 = useState([]),
    gardensValue = _useState18[0],
    setGardensValue = _useState18[1];
  var _useState19 = useState([]),
    farmsValue = _useState19[0],
    setFarmsValue = _useState19[1];
  var _useState20 = useState([]),
    earthenGreenhouseValue = _useState20[0],
    setEarthenGreenhouseValue = _useState20[1];
  var _useState21 = useState([]),
    hydroponicGreenhouseValue = _useState21[0],
    setHydroponicGreenhouseValue = _useState21[1];
  var _useState22 = useState([]),
    livestockAndBirdsValue = _useState22[0],
    setLivestockAndBirdsValue = _useState22[1];
  var _useState23 = useState([]),
    veterinaryValue = _useState23[0],
    setVeterinaryValue = _useState23[1];
  var gardenDefaultValue;
  var farmsDefaultValue;
  var earthenGreenhouseDefaultValue;
  var hydroponicGreenhouseDefaultValue;
  var livestockAndBirdsDefaultValue;
  var veterinaryDefaultValue;
  if (editableTitle === 'expertises') {
    gardenDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXPERTISES_GARDENS') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    farmsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXPERTISES_FARMS') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    earthenGreenhouseDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXPERTISES_EARTHEN_GREENHOUSE') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    hydroponicGreenhouseDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXPERTISES_HYDROPONIC_GREENHOUSE') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    livestockAndBirdsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXPERTISES_LIVESTOCK_POULTRY') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    veterinaryDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'EXPERTISES_VETERINARY_MEDICINE') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
  }
  var setGardens = function setGardens(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setGardensValue(items);
  };
  var setFarms = function setFarms(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setFarmsValue(items);
  };
  var setEarthenGreenhouse = function setEarthenGreenhouse(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setEarthenGreenhouseValue(items);
  };
  var setHydroponicGreenhouse = function setHydroponicGreenhouse(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setHydroponicGreenhouseValue(items);
  };
  var setLivestockAndBirds = function setLivestockAndBirds(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setLivestockAndBirdsValue(items);
  };
  var setVeterinary = function setVeterinary(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setVeterinaryValue(items);
  };
  var createExpertises = function createExpertises(fieldName) {
    (fieldName === null || fieldName === void 0 ? void 0 : fieldName.length) > 0 && (fieldName === null || fieldName === void 0 ? void 0 : fieldName.map(function (item) {
      expertisesEditedValue === null || expertisesEditedValue === void 0 ? void 0 : expertisesEditedValue.push({
        categoryEN: item === null || item === void 0 ? void 0 : item.categoryEN,
        categoryFA: item === null || item === void 0 ? void 0 : item.categoryFA,
        id: item === null || item === void 0 ? void 0 : item.id,
        name: item === null || item === void 0 ? void 0 : item.name
      });
    }));
  };
  var professionsEditedValue = [];
  var _useState24 = useState([]),
    agricultureAndGardenValue = _useState24[0],
    setAgricultureAndGardenValue = _useState24[1];
  var _useState25 = useState([]),
    greenhouseValue = _useState25[0],
    setgreenhouseValue = _useState25[1];
  var _useState26 = useState([]),
    livestockAndBirdsProfessionsValue = _useState26[0],
    setLivestockAndBirdsProfessionsValue = _useState26[1];
  var _useState27 = useState([]),
    veterinaryProfessionsValue = _useState27[0],
    setVeterinaryProfessionsValue = _useState27[1];
  var _useState28 = useState([]),
    comprehensiveProfessionsValue = _useState28[0],
    setComprehensiveProfessionsValue = _useState28[1];
  var agricultureAndGardenDefaultValue;
  var greenhouseDefaultValue;
  var livestockAndBirdsProfessionsDefaultValue;
  var veterinaryProfessionsDefaultValue;
  var comprehensiveProfessionsDefaultValue;
  if (editableTitle === 'professions') {
    agricultureAndGardenDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'PROFESSIONS_FARMS_AND_GARDENS') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    greenhouseDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'PROFESSIONS_GREENHOUSE') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    livestockAndBirdsProfessionsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'PROFESSIONS_LIVESTOCK_POULTRY') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    veterinaryProfessionsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'PROFESSIONS_VETERINARY_MEDICINE') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
    comprehensiveProfessionsDefaultValue = editableValue.map(function (item) {
      if (item.categoryEN === 'PROFESSIONS_COMPREHENSIVE_PROFESSIONS') {
        return {
          value: item.name,
          label: item.name,
          item: item
        };
      }
    }).filter(Boolean);
  }
  var setAgricultureAndGarden = function setAgricultureAndGarden(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setAgricultureAndGardenValue(items);
  };
  var setGreenhouse = function setGreenhouse(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setgreenhouseValue(items);
  };
  var setLivestockAndBirdsProfessions = function setLivestockAndBirdsProfessions(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setLivestockAndBirdsProfessionsValue(items);
  };
  var setVeterinaryProfessions = function setVeterinaryProfessions(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setVeterinaryProfessionsValue(items);
  };
  var setComprehensiveProfessions = function setComprehensiveProfessions(e) {
    var items = e.map(function (e) {
      return e.item;
    });
    setComprehensiveProfessionsValue(items);
  };
  var createProfessions = function createProfessions(fieldName) {
    (fieldName === null || fieldName === void 0 ? void 0 : fieldName.length) > 0 && (fieldName === null || fieldName === void 0 ? void 0 : fieldName.map(function (item) {
      professionsEditedValue === null || professionsEditedValue === void 0 ? void 0 : professionsEditedValue.push({
        categoryEN: item === null || item === void 0 ? void 0 : item.categoryEN,
        categoryFA: item === null || item === void 0 ? void 0 : item.categoryFA,
        id: item === null || item === void 0 ? void 0 : item.id,
        name: item === null || item === void 0 ? void 0 : item.name
      });
    }));
  };
  var onChangeHandler = function onChangeHandler(e) {
    if (e.target.type === 'file') {
      var file = e.target.files[0];
      if (typeof file === 'string') {
        setSelectedFile(e.target.files[0]);
      } else {
        setFileExtension(file.type.split('/')[1]);
        getBase64(e.target.files[0]);
      }
    } else {
      setEditedValue(e.target.value);
    }
  };
  var onPrivateAndNonCroppedFilesChangeHandler = function onPrivateAndNonCroppedFilesChangeHandler(e) {
    var file = e.target.files[0];
    setSelectedFile(e.target.files[0]);
    setFileExtension(file.type.split('/')[1]);
  };
  var queOnChangeHandler = function queOnChangeHandler(e, id) {
    var qev = queEditedValue.filter(function (item) {
      return id !== item.id;
    });
    qev.push({
      answer: e.target.value,
      id: id
    });
    setQueEditedValue(qev);
  };
  var trueFalseOnChangeHandler = function trueFalseOnChangeHandler(e) {
    setEditedValue(e);
  };
  var getBase64 = function getBase64(file) {
    return new Promise(function (resolve, reject) {
      var reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = function () {
        setSelectedFile(reader.result);
        return resolve(reader.result);
      };
      reader.onerror = function (error) {
        return reject(error);
      };
    });
  };
  var sendFileName = function sendFileName() {
    try {
      var _temp4 = _catch(function () {
        return Promise.resolve(axios.post(process.env.REACT_APP_BASE_URL + 'api/files/s3-upload-file', {
          filename: editableTitle + '.' + fileExtension
        })).then(function (response) {
          var _response$data, _response$data$data;
          var _response$data$data$r = response === null || response === void 0 ? void 0 : (_response$data = response.data) === null || _response$data === void 0 ? void 0 : (_response$data$data = _response$data.data) === null || _response$data$data === void 0 ? void 0 : _response$data$data.result,
            url = _response$data$data$r.url,
            fields = _response$data$data$r.fields;
          var key = fields.key;
          var formData = new FormData();
          Object.entries(fields).map(function (_ref2) {
            var key = _ref2[0],
              value = _ref2[1];
            formData.append(key, value);
          });
          fetch(cropedFile).then(function (res) {
            return res.blob();
          }).then(function (blob) {
            try {
              var file = new File([blob], editableTitle + '.' + fileExtension);
              formData.append('file', file);
              return Promise.resolve(axios.post(url, formData)).then(function (arvanResponse) {
                var _callBack;
                callBack((_callBack = {}, _callBack[editableTitle] = key, _callBack));
                setIsOpen(false);
                setModal(null);
              });
            } catch (e) {
              return Promise.reject(e);
            }
          });
        });
      }, function (error) {
        console.log('error', error);
        alert('خطا در ارسال فایل');
      });
      return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var sendPrivateAndNonCroppedFileName = function sendPrivateAndNonCroppedFileName() {
    try {
      var _temp6 = _catch(function () {
        return Promise.resolve(axios.post(process.env.REACT_APP_BASE_URL + 'api/files/s3-upload-file', {
          filename: editableTitle + '.' + fileExtension
        })).then(function (response) {
          var _response$data2, _response$data2$data;
          var _response$data$data$r2 = response === null || response === void 0 ? void 0 : (_response$data2 = response.data) === null || _response$data2 === void 0 ? void 0 : (_response$data2$data = _response$data2.data) === null || _response$data2$data === void 0 ? void 0 : _response$data2$data.result,
            url = _response$data$data$r2.url,
            fields = _response$data$data$r2.fields;
          var key = fields.key;
          var formData = new FormData();
          Object.entries(fields).map(function (_ref3) {
            var key = _ref3[0],
              value = _ref3[1];
            formData.append(key, value);
          });
          formData.append('file', selectedFile);
          return Promise.resolve(axios.post(url, formData)).then(function (arvanResponse) {
            var _callBack2;
            callBack((_callBack2 = {}, _callBack2[editableTitle] = key, _callBack2));
            setIsOpen(false);
            setModal(null);
          });
        });
      }, function (error) {
        console.log('error', error);
        alert('خطا در ارسال فایل');
      });
      return Promise.resolve(_temp6 && _temp6.then ? _temp6.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var getPrivateLink = function getPrivateLink() {
    try {
      return Promise.resolve(axios.get(process.env.REACT_APP_BASE_URL + ("api/files/" + editableValue))).then(function (response) {
        var _response$data3, _response$data3$data, _response$data3$data$;
        setPrivateLink(response === null || response === void 0 ? void 0 : (_response$data3 = response.data) === null || _response$data3 === void 0 ? void 0 : (_response$data3$data = _response$data3.data) === null || _response$data3$data === void 0 ? void 0 : (_response$data3$data$ = _response$data3$data.result) === null || _response$data3$data$ === void 0 ? void 0 : _response$data3$data$.url);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  function returnRelatedComponentForExperts() {
    switch (typeof editableValue) {
      case 'string':
        if (editableTitle === 'expectedPage') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "\u06A9\u0627\u0631\u062F\u0627\u0646",
            name: "expectedPage",
            defaultChecked: editedValue === 'کاردان',
            onChange: onChangeHandler
          }), "\u06A9\u0627\u0631\u062F\u0627\u0646"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "\u0645\u062A\u062E\u0635\u0635",
            name: "expectedPage",
            defaultChecked: editedValue === 'متخصص',
            onChange: onChangeHandler
          }), "\u0645\u062A\u062E\u0635\u0635"));
        } else if (editableTitle === 'avatar' || editableTitle === 'cover') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.imageSelectorContainer
          }, cropedFile ? /*#__PURE__*/React.createElement("img", {
            className: editableTitle === 'avatar' ? styles.avatar : styles.cover,
            src: cropedFile
          }) : selectedFile ? /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(Cropper, {
            image: selectedFile,
            crop: crop,
            zoom: zoom,
            aspect: editableTitle === 'avatar' ? 1 : 13 / 4,
            onCropChange: setCrop,
            onCropComplete: onCropComplete,
            onZoomChange: setZoom
          }), /*#__PURE__*/React.createElement("button", {
            className: styles.cropButton,
            onClick: showCroppedImage
          }, "\u0627\u0639\u0645\u0627\u0644")) : /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("img", {
            className: editableTitle === 'avatar' ? styles.avatar : styles.cover,
            src: 'https://s3.ir-thr-at1.arvanstorage.ir/' + editableValue
          }), /*#__PURE__*/React.createElement("label", {
            "for": "file-upload",
            className: styles.fileUpload
          }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
            className: styles.inputFile,
            id: "file-upload",
            type: "file",
            accept: ".jpg,.jpeg,.png",
            multiple: false,
            onChange: onChangeHandler
          })));
        } else if (editableTitle === 'identityDocument' || editableTitle === 'studentCard' || editableTitle === 'engineeringSystemCard') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.imageSelectorContainer
          }, privateLink ? /*#__PURE__*/React.createElement("a", {
            href: privateLink,
            target: "_blank"
          }, "\u062F\u0627\u0646\u0644\u0648\u062F \u0641\u0627\u06CC\u0644") : /*#__PURE__*/React.createElement("p", {
            onClick: getPrivateLink,
            className: styles.filePreviewLink
          }, "\u0645\u0634\u0627\u0647\u062F\u0647 \u0641\u0627\u06CC\u0644"), /*#__PURE__*/React.createElement("label", {
            "for": "file-upload",
            className: styles.fileUpload
          }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
            className: styles.inputFile,
            id: "file-upload",
            type: "file",
            accept: ".jpg,.jpeg,.png",
            multiple: false,
            onChange: onPrivateAndNonCroppedFilesChangeHandler
          }));
        } else if (editableTitle === 'resume') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.imageSelectorContainer
          }, /*#__PURE__*/React.createElement("a", {
            href: 'https://s3.ir-thr-at1.arvanstorage.ir/' + editableValue,
            target: "_blank"
          }, "\u062F\u0627\u0646\u0644\u0648\u062F \u0641\u0627\u06CC\u0644"), /*#__PURE__*/React.createElement("label", {
            "for": "file-upload",
            className: styles.fileUpload
          }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
            className: styles.inputFile,
            id: "file-upload",
            type: "file",
            accept: ".pdf",
            multiple: false,
            onChange: onPrivateAndNonCroppedFilesChangeHandler
          }));
        } else if (editableTitle === 'academicDegreeDocument') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.imageSelectorContainer
          }, privateLink ? /*#__PURE__*/React.createElement("a", {
            href: privateLink,
            target: "_blank"
          }, "\u062F\u0627\u0646\u0644\u0648\u062F \u0641\u0627\u06CC\u0644") : /*#__PURE__*/React.createElement("p", {
            onClick: getPrivateLink,
            className: styles.filePreviewLink
          }, "\u0645\u0634\u0627\u0647\u062F\u0647 \u0641\u0627\u06CC\u0644"), /*#__PURE__*/React.createElement("label", {
            "for": "file-upload",
            className: styles.fileUpload
          }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
            className: styles.inputFile,
            id: "file-upload",
            type: "file",
            accept: ".pdf, .jpg",
            multiple: false,
            onChange: onPrivateAndNonCroppedFilesChangeHandler
          }));
        } else if (editableTitle === 'aboutMe') {
          return /*#__PURE__*/React.createElement("textarea", {
            className: styles.bigCenterInput,
            type: "text",
            defaultValue: editableValue,
            onChange: onChangeHandler
          });
        } else {
          return /*#__PURE__*/React.createElement("input", {
            className: styles.centerInput,
            type: "text",
            defaultValue: editableValue,
            onChange: onChangeHandler
          });
        }
      case 'number':
        return /*#__PURE__*/React.createElement("input", {
          className: styles.centerInput,
          type: "number",
          defaultValue: editableValue,
          onChange: onChangeHandler
        });
      case 'boolean':
        if (editableTitle === 'agriculturalActivity') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "true",
            name: "agriculturalActivity",
            defaultChecked: editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u0628\u0644\u0647"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "",
            name: "agriculturalActivity",
            defaultChecked: !editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u062E\u06CC\u0631"));
        } else if (editableTitle == 'willingMakeVisit') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "true",
            name: "willingMakeVisit",
            defaultChecked: editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u0628\u0644\u0647"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "",
            name: "willingMakeVisit",
            defaultChecked: !editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u062E\u06CC\u0631"));
        } else if (editableTitle === 'hasVehicle') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "true",
            name: "hasVehicle",
            defaultChecked: editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u0628\u0644\u0647"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "",
            name: "hasVehicle",
            defaultChecked: !editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u062E\u06CC\u0631"));
        } else if (editableTitle === 'agriculturalEngineeringSystemOrganizationMember') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "true",
            name: "agriculturalEngineeringSystemOrganizationMember",
            defaultChecked: editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u0628\u0644\u0647"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "",
            name: "agriculturalEngineeringSystemOrganizationMember",
            defaultChecked: !editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u062E\u06CC\u0631"));
        } else if (editableTitle === 'phoneNumberIsPublic') {
          return /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "true",
            name: "phoneNumberIsPublic",
            defaultChecked: editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u0628\u0644\u0647"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: "",
            name: "phoneNumberIsPublic",
            defaultChecked: !editedValue,
            onChange: function onChange(e) {
              return trueFalseOnChangeHandler(Boolean(e.target.value));
            }
          }), "\u062E\u06CC\u0631"));
        }
      case 'object':
        if (editableTitle === 'academicDegree') {
          var _staticData$ACADEMIC_;
          useEffect(function () {
            var _academicDegreeDefaul, _academicDegreeDefaul2;
            setAcademicDegreeId((_academicDegreeDefaul = academicDegreeDefaultValue) === null || _academicDegreeDefaul === void 0 ? void 0 : (_academicDegreeDefaul2 = _academicDegreeDefaul.item) === null || _academicDegreeDefaul2 === void 0 ? void 0 : _academicDegreeDefaul2.id);
          }, []);
          var academicDegreeOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$ACADEMIC_ = staticData.ACADEMIC_DEGREE) === null || _staticData$ACADEMIC_ === void 0 ? void 0 : _staticData$ACADEMIC_.map(function (item) {
            if (item.categoryEN === 'ACADEMIC_DEGREE') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.singleSelect,
            IsMulti: false,
            name: "academicDegree",
            closeMenuOnSelect: true,
            components: animatedComponents,
            options: academicDegreeOptions,
            isSearchable: true,
            defaultValue: academicDegreeDefaultValue,
            onChange: setAcademicDegreeId
          });
        } else if (editableTitle === 'academicField') {
          var _staticData$ACADEMIC_2;
          useEffect(function () {
            var _academicFieldDefault, _academicFieldDefault2;
            setAcademicFieldId((_academicFieldDefault = academicFieldDefaultValue) === null || _academicFieldDefault === void 0 ? void 0 : (_academicFieldDefault2 = _academicFieldDefault.item) === null || _academicFieldDefault2 === void 0 ? void 0 : _academicFieldDefault2.id);
          }, []);
          var academicFieldOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$ACADEMIC_2 = staticData.ACADEMIC_FIELDS) === null || _staticData$ACADEMIC_2 === void 0 ? void 0 : _staticData$ACADEMIC_2.map(function (item) {
            if (item.categoryEN === 'ACADEMIC_FIELD') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.singleSelect,
            IsMulti: false,
            name: "academicField",
            closeMenuOnSelect: true,
            components: animatedComponents,
            options: academicFieldOptions,
            isSearchable: true,
            defaultValue: academicFieldDefaultValue,
            onChange: setAcademicFieldId
          });
        } else if (editableTitle === 'academicRank') {
          var _staticData$ACADEMIC_3;
          useEffect(function () {
            var _academicRankDefaultV, _academicRankDefaultV2;
            setAcademicRankId((_academicRankDefaultV = academicRankDefaultValue) === null || _academicRankDefaultV === void 0 ? void 0 : (_academicRankDefaultV2 = _academicRankDefaultV.item) === null || _academicRankDefaultV2 === void 0 ? void 0 : _academicRankDefaultV2.id);
          }, []);
          var academicRankOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$ACADEMIC_3 = staticData.ACADEMIC_RANKS) === null || _staticData$ACADEMIC_3 === void 0 ? void 0 : _staticData$ACADEMIC_3.map(function (item) {
            if (item.categoryEN === 'ACADEMIC_RANKS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.singleSelect,
            IsMulti: false,
            name: "academicRank",
            closeMenuOnSelect: true,
            components: animatedComponents,
            options: academicRankOptions,
            isSearchable: true,
            defaultValue: academicRankDefaultValue,
            onChange: setAcademicRankId
          });
        } else if (editableTitle === 'workplaceOrganizationPosition') {
          var _staticData$WORKPLACE;
          useEffect(function () {
            var _workplaceOrganizatio, _workplaceOrganizatio2;
            setWorkplaceOrganizationPositionId((_workplaceOrganizatio = workplaceOrganizationPositionDefaultValue) === null || _workplaceOrganizatio === void 0 ? void 0 : (_workplaceOrganizatio2 = _workplaceOrganizatio.item) === null || _workplaceOrganizatio2 === void 0 ? void 0 : _workplaceOrganizatio2.id);
          }, []);
          var workplaceOrganizationPositionOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$WORKPLACE = staticData.WORKPLACE_ORGANIZATIONS_POSITIONS) === null || _staticData$WORKPLACE === void 0 ? void 0 : _staticData$WORKPLACE.map(function (item) {
            if (item.categoryEN === 'WORKPLACE_ORGANIZATIONS_POSITIONS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.singleSelect,
            IsMulti: false,
            name: "workplaceOrganizationPosition",
            closeMenuOnSelect: true,
            components: animatedComponents,
            options: workplaceOrganizationPositionOptions,
            isSearchable: true,
            defaultValue: workplaceOrganizationPositionDefaultValue,
            onChange: setWorkplaceOrganizationPositionId
          });
        } else if (editableTitle === 'workplaceOrganizationType') {
          var _staticData$WORKPLACE2;
          useEffect(function () {
            var _workplaceOrganizatio3, _workplaceOrganizatio4;
            setWorkplaceOrganizationTypeId((_workplaceOrganizatio3 = workplaceOrganizationTypeDefaultValue) === null || _workplaceOrganizatio3 === void 0 ? void 0 : (_workplaceOrganizatio4 = _workplaceOrganizatio3.item) === null || _workplaceOrganizatio4 === void 0 ? void 0 : _workplaceOrganizatio4.id);
          }, []);
          var workplaceOrganizationTypeOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$WORKPLACE2 = staticData.WORKPLACE_ORGANIZATIONS) === null || _staticData$WORKPLACE2 === void 0 ? void 0 : _staticData$WORKPLACE2.map(function (item) {
            if (item.categoryEN === 'WORKPLACE_ORGANIZATIONS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.singleSelect,
            IsMulti: false,
            name: "workplaceOrganizationType",
            closeMenuOnSelect: true,
            components: animatedComponents,
            options: workplaceOrganizationTypeOptions,
            isSearchable: true,
            defaultValue: workplaceOrganizationTypeDefaultValue,
            onChange: setWorkplaceOrganizationTypeId
          });
        } else if (editableTitle === 'activityFields') {
          var _staticData$EXECUTIVE;
          useEffect(function () {
            setActivities(activityFieldsDefaultValue);
          }, []);
          var activityFieldsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXECUTIVE = staticData.EXECUTIVE_SKILLS) === null || _staticData$EXECUTIVE === void 0 ? void 0 : _staticData$EXECUTIVE.map(function (item) {
            if (item.categoryEN === 'EXECUTIVE_SKILLS_ACTIVITY') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "activityFields",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: activityFieldsOptions,
            isSearchable: true,
            defaultValue: activityFieldsDefaultValue,
            onChange: setActivities
          });
        } else if (editableTitle === 'consultingFields') {
          var _staticData$EXECUTIVE2;
          useEffect(function () {
            setConsultings(consultingFieldsDefaultValue);
          }, []);
          var consultingFieldsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXECUTIVE2 = staticData.EXECUTIVE_SKILLS) === null || _staticData$EXECUTIVE2 === void 0 ? void 0 : _staticData$EXECUTIVE2.map(function (item) {
            if (item.categoryEN === 'EXECUTIVE_SKILLS_CONSULTING') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "consultingFields",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: consultingFieldsOptions,
            isSearchable: true,
            defaultValue: consultingFieldsDefaultValue,
            onChange: setConsultings
          });
        } else if (editableTitle === 'expertises') {
          var _staticData$EXPERTISE, _staticData$EXPERTISE2, _staticData$EXPERTISE3, _staticData$EXPERTISE4, _staticData$EXPERTISE5, _staticData$EXPERTISE6;
          useEffect(function () {
            setGardens(gardenDefaultValue);
            setFarms(farmsDefaultValue);
            setEarthenGreenhouse(earthenGreenhouseDefaultValue);
            setHydroponicGreenhouse(hydroponicGreenhouseDefaultValue);
            setLivestockAndBirds(livestockAndBirdsDefaultValue);
            setVeterinary(veterinaryDefaultValue);
          }, []);
          var gardensOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXPERTISE = staticData.EXPERTISES) === null || _staticData$EXPERTISE === void 0 ? void 0 : _staticData$EXPERTISE.map(function (item) {
            if (item.categoryEN === 'EXPERTISES_GARDENS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var farmsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXPERTISE2 = staticData.EXPERTISES) === null || _staticData$EXPERTISE2 === void 0 ? void 0 : _staticData$EXPERTISE2.map(function (item) {
            if (item.categoryEN === 'EXPERTISES_FARMS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var earthenGreenhouseOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXPERTISE3 = staticData.EXPERTISES) === null || _staticData$EXPERTISE3 === void 0 ? void 0 : _staticData$EXPERTISE3.map(function (item) {
            if (item.categoryEN === 'EXPERTISES_EARTHEN_GREENHOUSE') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var hydroponicGreenhouseOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXPERTISE4 = staticData.EXPERTISES) === null || _staticData$EXPERTISE4 === void 0 ? void 0 : _staticData$EXPERTISE4.map(function (item) {
            if (item.categoryEN === 'EXPERTISES_HYDROPONIC_GREENHOUSE') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var livestockAndBirdsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXPERTISE5 = staticData.EXPERTISES) === null || _staticData$EXPERTISE5 === void 0 ? void 0 : _staticData$EXPERTISE5.map(function (item) {
            if (item.categoryEN === 'EXPERTISES_LIVESTOCK_POULTRY') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var veterinaryOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$EXPERTISE6 = staticData.EXPERTISES) === null || _staticData$EXPERTISE6 === void 0 ? void 0 : _staticData$EXPERTISE6.map(function (item) {
            if (item.categoryEN === 'EXPERTISES_VETERINARY_MEDICINE') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.row
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u0628\u0627\u063A\u0627\u062A"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "gardens",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: gardensOptions,
            isSearchable: true,
            defaultValue: gardenDefaultValue,
            onChange: setGardens
          })), /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u0645\u0632\u0627\u0631\u0639"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "farms",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: farmsOptions,
            isSearchable: true,
            defaultValue: farmsDefaultValue,
            onChange: setFarms
          }))), /*#__PURE__*/React.createElement("div", {
            className: styles.row
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u06AF\u0644\u062E\u0627\u0646\u0647 \u062E\u0627\u06A9\u06CC"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "earthenGreenhouse",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: earthenGreenhouseOptions,
            isSearchable: true,
            defaultValue: earthenGreenhouseDefaultValue,
            onChange: setEarthenGreenhouse
          })), /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u06AF\u0644\u062E\u0627\u0646\u0647 \u0647\u06CC\u062F\u0631\u0648\u067E\u0648\u0646\u06CC\u06A9"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "hydroponicGreenhouse",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: hydroponicGreenhouseOptions,
            isSearchable: true,
            defaultValue: hydroponicGreenhouseDefaultValue,
            onChange: setHydroponicGreenhouse
          }))), /*#__PURE__*/React.createElement("div", {
            className: styles.row
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u062F\u0627\u0645 \u0648 \u0637\u06CC\u0648\u0631"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "livestockAndBirds",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: livestockAndBirdsOptions,
            isSearchable: true,
            defaultValue: livestockAndBirdsDefaultValue,
            onChange: setLivestockAndBirds
          })), /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u062F\u0627\u0645\u067E\u0632\u0634\u06A9\u06CC"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "veterinary",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: veterinaryOptions,
            isSearchable: true,
            defaultValue: veterinaryDefaultValue,
            onChange: setVeterinary
          }))));
        } else if (editableTitle === 'professions') {
          var _staticData$PROFESSIO, _staticData$PROFESSIO2, _staticData$PROFESSIO3, _staticData$PROFESSIO4, _staticData$PROFESSIO5;
          useEffect(function () {
            setAgricultureAndGarden(agricultureAndGardenDefaultValue);
            setGreenhouse(greenhouseDefaultValue);
            setLivestockAndBirdsProfessions(livestockAndBirdsProfessionsDefaultValue);
            setVeterinaryProfessions(veterinaryProfessionsDefaultValue);
            setComprehensiveProfessions(comprehensiveProfessionsDefaultValue);
          }, []);
          var agricultureAndGardenOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$PROFESSIO = staticData.PROFESSIONS) === null || _staticData$PROFESSIO === void 0 ? void 0 : _staticData$PROFESSIO.map(function (item) {
            if (item.categoryEN === 'PROFESSIONS_FARMS_AND_GARDENS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var greenhouseOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$PROFESSIO2 = staticData.PROFESSIONS) === null || _staticData$PROFESSIO2 === void 0 ? void 0 : _staticData$PROFESSIO2.map(function (item) {
            if (item.categoryEN === 'PROFESSIONS_GREENHOUSE') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var _livestockAndBirdsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$PROFESSIO3 = staticData.PROFESSIONS) === null || _staticData$PROFESSIO3 === void 0 ? void 0 : _staticData$PROFESSIO3.map(function (item) {
            if (item.categoryEN === 'PROFESSIONS_LIVESTOCK_POULTRY') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var veterinaryProfessionsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$PROFESSIO4 = staticData.PROFESSIONS) === null || _staticData$PROFESSIO4 === void 0 ? void 0 : _staticData$PROFESSIO4.map(function (item) {
            if (item.categoryEN === 'PROFESSIONS_VETERINARY_MEDICINE') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          var comprehensiveProfessionsOptions = staticData === null || staticData === void 0 ? void 0 : (_staticData$PROFESSIO5 = staticData.PROFESSIONS) === null || _staticData$PROFESSIO5 === void 0 ? void 0 : _staticData$PROFESSIO5.map(function (item) {
            if (item.categoryEN === 'PROFESSIONS_COMPREHENSIVE_PROFESSIONS') {
              return {
                value: item.name,
                label: item.name,
                item: item
              };
            }
          }).filter(Boolean);
          return /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.row
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u0632\u0631\u0627\u0639\u062A \u0648 \u0628\u0627\u063A"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "agricultureAndGarden",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: agricultureAndGardenOptions,
            isSearchable: true,
            defaultValue: agricultureAndGardenDefaultValue,
            onChange: setAgricultureAndGarden
          })), /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u06AF\u0644\u062E\u0627\u0646\u0647"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "greenhouse",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: greenhouseOptions,
            isSearchable: true,
            defaultValue: greenhouseDefaultValue,
            onChange: setGreenhouse
          }))), /*#__PURE__*/React.createElement("div", {
            className: styles.row
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u062F\u0627\u0645 \u0648 \u0637\u06CC\u0648\u0631"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "livestockAndBirdsProfessions",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: _livestockAndBirdsOptions,
            isSearchable: true,
            defaultValue: livestockAndBirdsProfessionsDefaultValue,
            onChange: setLivestockAndBirdsProfessions
          })), /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u062F\u0627\u0645\u067E\u0632\u0634\u06A9\u06CC"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "veterinaryProfessions",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: veterinaryProfessionsOptions,
            isSearchable: true,
            defaultValue: veterinaryProfessionsDefaultValue,
            onChange: setVeterinaryProfessions
          }))), /*#__PURE__*/React.createElement("div", {
            className: styles.row
          }, /*#__PURE__*/React.createElement("div", {
            className: styles.element
          }, /*#__PURE__*/React.createElement("label", null, "\u062D\u0631\u0641 \u062C\u0627\u0645\u0639"), /*#__PURE__*/React.createElement(Select, {
            className: styles.multiSelect,
            name: "comprehensiveProfessions",
            closeMenuOnSelect: true,
            components: animatedComponents,
            isMulti: true,
            options: comprehensiveProfessionsOptions,
            isSearchable: true,
            defaultValue: comprehensiveProfessionsDefaultValue,
            onChange: setComprehensiveProfessions
          }))));
        } else {
          if (editableTitle === 'avatar' || editableTitle === 'cover') {
            return /*#__PURE__*/React.createElement("div", {
              className: styles.imageSelectorContainer
            }, cropedFile ? /*#__PURE__*/React.createElement("img", {
              className: editableTitle === 'avatar' ? styles.avatar : styles.cover,
              src: cropedFile
            }) : selectedFile ? /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(Cropper, {
              image: selectedFile,
              crop: crop,
              zoom: zoom,
              aspect: editableTitle === 'avatar' ? 1 : 13 / 4,
              onCropChange: setCrop,
              onCropComplete: onCropComplete,
              onZoomChange: setZoom
            }), /*#__PURE__*/React.createElement("button", {
              className: styles.cropButton,
              onClick: showCroppedImage
            }, "\u0627\u0639\u0645\u0627\u0644")) : /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("img", {
              className: editableTitle === 'avatar' ? styles.avatar : styles.cover,
              src: 'https://s3.ir-thr-at1.arvanstorage.ir/' + editableValue
            }), /*#__PURE__*/React.createElement("label", {
              "for": "file-upload",
              className: styles.fileUpload
            }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
              className: styles.inputFile,
              id: "file-upload",
              type: "file",
              accept: ".jpg,.jpeg,.png",
              multiple: false,
              onChange: onChangeHandler
            })));
          } else if (editableTitle === 'identityDocument' || editableTitle === 'studentCard' || editableTitle === 'engineeringSystemCard') {
            return /*#__PURE__*/React.createElement("div", {
              className: styles.imageSelectorContainer
            }, privateLink ? /*#__PURE__*/React.createElement("a", {
              href: privateLink,
              target: "_blank"
            }, "\u062F\u0627\u0646\u0644\u0648\u062F \u0641\u0627\u06CC\u0644") : /*#__PURE__*/React.createElement("p", {
              onClick: getPrivateLink,
              className: styles.filePreviewLink
            }, "\u0645\u0634\u0627\u0647\u062F\u0647 \u0641\u0627\u06CC\u0644"), /*#__PURE__*/React.createElement("label", {
              "for": "file-upload",
              className: styles.fileUpload
            }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
              className: styles.inputFile,
              id: "file-upload",
              type: "file",
              accept: ".jpg,.jpeg,.png",
              multiple: false,
              onChange: onPrivateAndNonCroppedFilesChangeHandler
            }));
          } else if (editableTitle === 'resume') {
            return /*#__PURE__*/React.createElement("div", {
              className: styles.imageSelectorContainer
            }, /*#__PURE__*/React.createElement("a", {
              href: 'https://s3.ir-thr-at1.arvanstorage.ir/' + editableValue,
              target: "_blank"
            }, "\u062F\u0627\u0646\u0644\u0648\u062F \u0641\u0627\u06CC\u0644"), /*#__PURE__*/React.createElement("label", {
              "for": "file-upload",
              className: styles.fileUpload
            }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
              className: styles.inputFile,
              id: "file-upload",
              type: "file",
              accept: ".pdf",
              multiple: false,
              onChange: onPrivateAndNonCroppedFilesChangeHandler
            }));
          } else if (editableTitle === 'academicDegreeDocument') {
            return /*#__PURE__*/React.createElement("div", {
              className: styles.imageSelectorContainer
            }, privateLink ? /*#__PURE__*/React.createElement("a", {
              href: privateLink,
              target: "_blank"
            }, "\u062F\u0627\u0646\u0644\u0648\u062F \u0641\u0627\u06CC\u0644") : /*#__PURE__*/React.createElement("p", {
              onClick: getPrivateLink,
              className: styles.filePreviewLink
            }, "\u0645\u0634\u0627\u0647\u062F\u0647 \u0641\u0627\u06CC\u0644"), /*#__PURE__*/React.createElement("label", {
              "for": "file-upload",
              className: styles.fileUpload
            }, "\u0622\u067E\u0644\u0648\u062F \u0641\u0627\u06CC\u0644 \u062C\u062F\u06CC\u062F"), /*#__PURE__*/React.createElement("input", {
              className: styles.inputFile,
              id: "file-upload",
              type: "file",
              accept: ".pdf, .jpg",
              multiple: false,
              onChange: onPrivateAndNonCroppedFilesChangeHandler
            }));
          } else {
            return /*#__PURE__*/React.createElement("input", {
              className: styles.centerInput,
              type: "text",
              defaultValue: editableValue,
              onChange: onChangeHandler
            });
          }
        }
    }
  }
  function returnRelatedComponentForQuestionnaires() {
    var elemetns = editableValue.map(function (ev, index) {
      switch (ev.type) {
        case EDIT_TEXT_TEXT:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement("input", {
            className: styles.centerInput,
            type: "text",
            defaultValue: ev.answer,
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }));
        case EDIT_TEXT_NUMBER:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement("input", {
            className: styles.centerInput,
            type: "number",
            defaultValue: ev.answer,
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }));
        case DATE:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement(DatePicker, {
            ev: ev,
            queEditedValue: queEditedValue,
            setQueEditedValue: setQueEditedValue
          }));
        case RADIOBUTTON:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement("div", {
            className: styles.radioButtonContainer
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: ev.list[0],
            name: ev.id,
            defaultChecked: ev.answer === ev.list[0],
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }), ev.list[0]), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            value: ev.list[1],
            name: ev.id,
            defaultChecked: ev.answer === ev.list[1],
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }), ev.list[1])));
        case SELECTION:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement("select", {
            defaultValue: ev.answer,
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }, ev.list.map(function (opt, index) {
            return /*#__PURE__*/React.createElement("option", {
              key: index,
              value: opt
            }, opt);
          })));
        case AREA:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement("input", {
            className: styles.centerInput,
            type: "text",
            defaultValue: ev.answer,
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }));
        case WEIGHT:
          return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("p", null, ev.text), /*#__PURE__*/React.createElement("input", {
            className: styles.centerInput,
            type: "text",
            defaultValue: ev.answer,
            onChange: function onChange(event) {
              return queOnChangeHandler(event, ev.id);
            }
          }));
        default:
          return alert(ev.type);
      }
    });
    return elemetns;
  }
  var setAcademicDegree = function setAcademicDegree() {
    var _callBack3;
    createAcademicDegree(academicDegreeIdValue);
    callBack((_callBack3 = {}, _callBack3[editableTitle + 'Id'] = academicDegreeIdEditedValue, _callBack3));
  };
  var setAcademicField = function setAcademicField() {
    var _callBack4;
    callBack((_callBack4 = {}, _callBack4[editableTitle + 'Id'] = academicDegreeIdEditedValue, _callBack4));
  };
  var setAcademicRank = function setAcademicRank() {
    var _callBack5;
    createAcademicRank(academicRankIdValue);
    callBack((_callBack5 = {}, _callBack5[editableTitle + 'Id'] = academicRankIdEditedValue, _callBack5));
  };
  var setActivityFields = function setActivityFields() {
    var _callBack6;
    createActivities(activityFieldsValue);
    callBack((_callBack6 = {}, _callBack6[editableTitle + 'Ids'] = activityFieldsEditedValue.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.id;
    }), _callBack6));
  };
  var setConsultingFields = function setConsultingFields() {
    var _callBack7;
    createConsultings(consultingFieldsValue);
    callBack((_callBack7 = {}, _callBack7[editableTitle + 'Ids'] = consultingFieldsEditedValue.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.id;
    }), _callBack7));
  };
  var setWorkplaceOrganizationPosition = function setWorkplaceOrganizationPosition() {
    var _callBack8;
    createWorkplaceOrganizationPosition(workplaceOrganizationPositionIdValue);
    callBack((_callBack8 = {}, _callBack8[editableTitle + 'Id'] = workplaceOrganizationPositionIdEditedValue, _callBack8));
  };
  var setWorkplaceOrganizationType = function setWorkplaceOrganizationType() {
    var _callBack9;
    createWorkplaceOrganizationType(workplaceOrganizationTypeIdValue);
    callBack((_callBack9 = {}, _callBack9[editableTitle + 'Id'] = workplaceOrganizationTypeIdEditedValue, _callBack9));
  };
  var setExpertises = function setExpertises() {
    var _callBack10;
    createExpertises(gardensValue);
    createExpertises(farmsValue);
    createExpertises(earthenGreenhouseValue);
    createExpertises(hydroponicGreenhouseValue);
    createExpertises(livestockAndBirdsValue);
    createExpertises(veterinaryValue);
    callBack((_callBack10 = {}, _callBack10[editableTitle + 'Ids'] = expertisesEditedValue.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.id;
    }), _callBack10));
  };
  var setProfessions = function setProfessions() {
    var _callBack11;
    createProfessions(agricultureAndGardenValue);
    createProfessions(greenhouseValue);
    createProfessions(livestockAndBirdsProfessionsValue);
    createProfessions(veterinaryProfessionsValue);
    createProfessions(comprehensiveProfessionsValue);
    callBack((_callBack11 = {}, _callBack11[editableTitle + 'Ids'] = professionsEditedValue.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.id;
    }), _callBack11));
  };
  var onModalOk = function onModalOk() {
    if (editableTitle === 'expertises') {
      setExpertises();
    } else if (editableTitle === 'professions') {
      setProfessions();
    } else if (editableTitle === 'activityFields') {
      setActivityFields();
    } else if (editableTitle === 'consultingFields') {
      setConsultingFields();
    } else if (editableTitle === 'academicDegree') {
      setAcademicDegree();
    } else if (editableTitle === 'academicField') {
      setAcademicField();
    } else if (editableTitle === 'academicRank') {
      setAcademicRank();
    } else if (editableTitle === 'workplaceOrganizationPosition') {
      setWorkplaceOrganizationPosition();
    } else if (editableTitle === 'workplaceOrganizationType') {
      setWorkplaceOrganizationType();
    } else if (editableTitle === 'avatar' || editableTitle === 'cover') {
      if (selectedFile) {
        if (cropedFile) {
          sendFileName();
        } else {
          alert('دکمه اعمال برش را بزنید');
        }
      } else {
        callBack('NOT_MODIFIED');
        setModal(null);
        setIsOpen(false);
      }
    } else if (editableTitle === 'academicDegreeDocument' || editableTitle === 'identityDocument' || editableTitle === 'studentCard' || editableTitle === 'engineeringSystemCard' || editableTitle === 'resume') {
      if (selectedFile) {
        sendPrivateAndNonCroppedFileName();
      } else {
        callBack('NOT_MODIFIED');
        setModal(null);
        setIsOpen(false);
      }
    } else if (forWhat === 'QUE') {
      var _data;
      setEdited({
        data: (_data = {}, _data[editableTitle] = queEditedValue, _data)
      });
    } else {
      var _callBack12;
      callBack((_callBack12 = {}, _callBack12[editableTitle] = editedValue, _callBack12));
    }
    if (editableTitle !== 'academicDegreeDocument' && editableTitle !== 'avatar' && editableTitle !== 'cover' && editableTitle !== 'engineeringSystemCard' && editableTitle !== 'resume' && editableTitle !== 'studentCard' && editableTitle !== 'nationalCard') {
      setIsOpen(false);
      setModal(null);
    }
  };
  return /*#__PURE__*/React.createElement(Modal$1, {
    centered: true,
    title: "\u0648\u06CC\u0631\u0627\u06CC\u0634",
    visible: true,
    footer: [/*#__PURE__*/React.createElement(Button, {
      key: "submit",
      onClick: onModalOk
    }, "\u062A\u0627\u06CC\u06CC\u062F"), /*#__PURE__*/React.createElement(Button, {
      key: "cancel",
      onClick: function onClick() {
        setModal(null);
        setIsOpen(false);
      }
    }, "\u0644\u063A\u0648"), (editableTitle === 'academicDegreeDocument' || editableTitle === 'avatar' || editableTitle === 'cover' || editableTitle === 'engineeringSystemCard' || editableTitle === 'resume' || editableTitle === 'studentCard' || editableTitle === 'nationalCard') && /*#__PURE__*/React.createElement(Button, {
      key: "delete",
      onClick: function onClick() {
        var _callBack13;
        callBack((_callBack13 = {}, _callBack13[editableTitle] = null, _callBack13));
        setModal(null);
        setIsOpen(false);
      }
    }, "\u062D\u0630\u0641")]
  }, forWhat === 'EXP' ? returnRelatedComponentForExperts() : returnRelatedComponentForQuestionnaires());
};

var EditorContainer = function EditorContainer(_ref) {
  var toEdit = _ref.toEdit,
    callBack = _ref.callBack,
    setEdited = _ref.setEdited,
    setModal = _ref.setModal,
    staticData = _ref.staticData,
    forWhat = _ref.forWhat;
  var _useState = useState(toEdit),
    editable = _useState[0];
  var _Object$entries = Object.entries(editable),
    element = _Object$entries[0];
  var _useState2 = useState(true),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  return /*#__PURE__*/React.createElement("div", null, isOpen && /*#__PURE__*/React.createElement(Modal, {
    setModal: setModal,
    setIsOpen: setIsOpen,
    callBack: callBack,
    setEdited: setEdited,
    editableTitle: element[0],
    editableValue: element[1],
    staticData: staticData,
    forWhat: forWhat
  }));
};

export { EditorContainer };
//# sourceMappingURL=index.modern.js.map
